#include <fstream>
#include <iostream>

#include <rlcsa/bits/bitbuffer.h>

#include "sadacount.h"


int
main(int argc, char** argv)
{
  if(argc < 2)
  {
    std::cout << "Usage: runs_in_sadacount base_name1 [base_name2 ...]" << std::endl;
    return 1;
  }

  for(int arg = 1; arg < argc; arg++)
  {
    std::string base_name = argv[arg];
    std::string input_name = base_name + SADACOUNT_EXTENSION;
    std::ifstream input(input_name.c_str(), std::ios_base::binary);
    if(!input)
    {
      std::cerr << "runs_in_sadacount: Cannot open input file " << input_name << std::endl;
      continue;
    }
    usint bits = 0;
    input.read((char*)&bits, sizeof(bits));
    CSA::ReadBuffer buffer(input, bits, 1);
    input.close();

    usint prev = CSA::WORD_MAX;
    usint runs = 0;
    while(buffer.hasNextItem())
    {
      usint curr = buffer.nextItem();
      if(curr != prev) { runs++; }
      prev = curr;
    }
    std::cout << base_name << ";" << runs << std::endl;
  }

  return 0;
}
